TICKIT_RUN(3)

NAME
tickit_run, tickit_stop, tickit_tick - control the event loop of the toplevel instance

SYNOPSIS
    #include <tickit.h>

    void tickit_run(Tickit *t);
    void tickit_stop(Tickit *t);

    void tickit_tick(Tickit *t, TickitRunFlags flags);

Link with -ltickit.

DESCRIPTION
tickit_run() starts the IO event loop of the main toplevel instance, allowing it to receive and react to terminal input, and to send output content back to it. Once invoked, this function will block processing IO and not return until the tickit_stop() function is called, or until a SIGINT is received (usually by the user pressing Ctrl-C).

tickit_stop() causes a currently-running call to tickit_run() to return.

tickit_tick() runs one iteration of the IO loop and returns. Its behaviour is controlled by the flags argument, which should be a bitmask of the following flags:

TICKIT_RUN_NOHANG
    Perform only a single round of IO without blocking. tickit_tick() will check for IO, or timers that are ready, handle those, and return. but will not block further waiting if nothing is yet ready.

TICKIT_RUN_NOSETUP
    Do not perform any terminal setup before waiting on IO events. Usually this is only necessary early in startup, if the program is using the Tickit event loop for its own purposes before starting a terminal interface.

    Without this flag, terminal setup will be run once the first time tickit_run or tickit_tick is called, and will remain valid until the toplevel instance is destroyed.

RETURN VALUE
Neither tickit_run(), tickit_stop() nor tickit_tick() return a value.

SEE ALSO
tickit_new_stdio(3), tickit(7)